<?php
namespace de::phpdesignpatterns::example;

class Car implements Iterator {
    public $manufacturer;
    public $color;
    protected $milage;

    private $iterableProperties = array(
                                    'manufacturer',
                                    'color',
                                    'milage'
                                  );
    private $position = 0;

    public function __construct($manufacturer, $color, $milage = 0) {
        $this->manufacturer = $manufacturer;
        $this->color = $color;
        $this->milage = $milage;
    }

    public function rewind() {
        $this->position = 0;
    }

    public function next() {
        $this->position++;
    }

    public function key() {
        return $this->iterableProperties[$this->position];
    }

    public function &current() {
        $key = $this->key();
        return $this->$key;
    }

    public function valid() {
        if ($this->position < count($this->iterableProperties)) {
        	return true;
        }
        return false;
    }
}

$bmw = new Car('BMW', 'blau', 500);

$bmw->rewind();
while ($bmw->valid()) {
	$key = $bmw->key();
	$value = $bmw->current();
	echo "{$key} => {$value}\n";
	$bmw->next();
}

foreach ($bmw as $key => $value) {
    echo "{$key} => {$value}\n";
}
?>